<?php

class beDiyoApi {
    public $server;
    public function beTestConnection($data){
        $response = $this->beSendRequestVMPanel([
            "method" => "checkuser",
            "apiurl" => $data["address"],
            "data" => [
                "email" => $data["username"],
                "password" => $data["password"],
                "hash" => $data["access_hash"]
            ]
        ]);
        if(!$response["status"]){
            return ["status" => false,"message" => $response["message"]];
        }
        return ["status" => true];
    }
    public function beCreateVM($server){
        $diyovm = $this->server;
        $server = array_merge($server,[
            "email" => $diyovm["username"],
            "password" => $diyovm["password"],
            "hash" => $diyovm["access_hash"]
        ]);
        $response = $this->beSendRequestVMPanel([
            "method" => "createvm",
            "apiurl" => $diyovm["name"],
            "data" => $server
        ]);
        return $response;
    }
    public function beUpdateVM($server){
        $diyovm = $this->server;
        $server = array_merge($server,[
            "email" => $diyovm["username"],
            "password" => $diyovm["password"],
            "hash" => $diyovm["access_hash"]
        ]);
        $response = $this->beSendRequestVMPanel([
            "method" => "updatevm",
            "apiurl" => $diyovm["name"],
            "data" => $server
        ]);
        return $response;
    }
    public function beGetTask($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "gettask",
            "apiurl" => $diyovm["name"],
            "data" => [
                "taskid" => $options["taskid"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beGetVm($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "getvm",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "iplist" => $options["iplist"],
                "snapshotlist" => $options["snapshotlist"],
                "templatelist" => $options["templatelist"],
                "logs" => $options["logs"],
                "rdnslist" => $options["rdnslist"],
                "stats" => $options["stats"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beGetPlans($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "getplans",
            "apiurl" => $diyovm["name"],
            "data" => [
                "pid" => $options["pid"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beGetTemplates($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "gettemplates",
            "apiurl" => $diyovm["name"],
            "data" => [
                "tid" => $options["tid"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beStatusAction($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "statusaction",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "action" => $options["action"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beEntegrationNetwork($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "networkvm",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beEntegrationDisk($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "diskvm",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beCreateSnapshot($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "createsnapshot",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beDeploySnapshot($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "deploysnapshot",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "ssid" => $options["ssid"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beDeleteSnapshot($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "deletesnapshot",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "ssid" => $options["ssid"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beCreateDnsRecord($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "createrdnsrecord",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "iid" => $options["iid"],
                "type" => $options["type"],
                "dns" => $options["dns"],
                "priority" => $options["priority"],
                "ttl" => $options["ttl"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beEditDnsRecord($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "editrdnsrecord",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "rid" => $options["rid"],
                "iid" => $options["iid"],
                "type" => $options["type"],
                "dns" => $options["dns"],
                "priority" => $options["priority"],
                "ttl" => $options["ttl"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beDeleteDnsRecord($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "deleterdnsrecord",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "rid" => $options["rid"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function bePasswordVM($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "passwordvm",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "onserver" => $options["onserver"],
                "password_vm" => $options["password"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beSuspend($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "suspendvm",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "action" => $options["action"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beFormatVM($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "formatvm",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "template" => $options["template"],
                "password_vm" => $options["password"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beDeleteVM($options){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "deletevm",
            "apiurl" => $diyovm["name"],
            "data" => [
                "vm_id" => $options["vm_id"],
                "password_vm" => $options["password"],
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beGetIPList(){
        $diyovm = $this->server;
        $response = $this->beSendRequestVMPanel([
            "method" => "iplist",
            "apiurl" => $diyovm["name"],
            "data" => [
                "email" => $diyovm["username"],
                "password" => $diyovm["password"],
                "hash" => $diyovm["access_hash"]
            ]
        ]);
        return $response;
    }
    public function beSetServer($server){
        $this->server = $server;
    }
    protected function beSendRequestVMPanel($data = []){
        $data["data"]["ipaddress"] = $_SERVER["SERVER_ADDR"];
        if(!$data["data"]["ipaddress"]){
            $data["data"]["ipaddress"] = "0.0.0.0";
        }
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,"https://{$data['apiurl']}/api/{$data['method']}");
        curl_setopt($ch,CURLOPT_POST,1);
        curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,false);
        curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);
        curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query($data["data"]));
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
        $response = curl_exec($ch);
        curl_close($ch);
        return json_decode($response,true);
    }
}

?>